// Original: Backmatic2 common.c
#include <windows.h>
#include "strtable.h"

#define halloc(s) HeapAlloc(GetProcessHeap(), 0, s)
#define hrealloc(p, s) HeapReAlloc(GetProcessHeap(), 0, p, s)
#define hfree(p) HeapFree(GetProcessHeap(), 0, p)

typedef struct tagSTRINGS{
	UINT id;
	LPTSTR str;
	struct tagSTRINGS* next;
} STRINGS;
static STRINGS* LoadedStrings = NULL;

// Win95 NO OSRłLoadStringAcchMax𕶎ƂČoO邽ߎʁB
LPCTSTR AllocLoadString(UINT id_string)
{
	LPTSTR ret = halloc(256);
	HINSTANCE hInst = GetModuleHandle(NULL);
	int n;

	{
		TCHAR tmp[3];

		if(!LoadString(hInst, id_string, tmp, 3))
			return (LPTSTR)TEXT("<<NO STRING RESOURCE FOUND>>");
	}

	if(LoadedStrings)
	{
		STRINGS* s;

		for(s = LoadedStrings; s; s = s->next)
		{
			if(s->id == id_string)
				return s->str;
		}
	}

	for(n = 0; ret; n++, ret = hrealloc(ret, 256 + n * 256))
	{
		int copied;

		//memset(ret + (n * 256), '\0', 256);	// hrealloc̓f[^ێB
		{
			int i;
			for(i = 0; i < 256; i++)
				*(ret + (n * 256) + i) = 0;
		}

		copied = LoadString(hInst, id_string, ret, 256 + n * 256);
		if(copied < 256 + n * 256 - 1)
		{
			// ʂȃRXgĂ݂Ȃ
			/*
			char *pc = ret + 256 + n * 256;
			for(; pc != ret && *pc == '\0'; pc--)
				;
			if(*pc)
				pc++;
			ret = hrealloc(ret, pc - ret + 1);
			*/
			break;
		}
	}

	{
		STRINGS* s;

		if(LoadedStrings)
			for(s = LoadedStrings; s->next; s = s->next)
				;

		if(LoadedStrings)
		{
			if(!(s->next = halloc(sizeof(STRINGS))))
			{
				hfree(ret);
				return NULL;
			}
			s = s->next;
		}else
		{
			if(!(LoadedStrings = s = halloc(sizeof(STRINGS))))
			{
				hfree(ret);
				return NULL;
			}
		}

		s->id = id_string;
		s->str = ret;
		s->next = NULL;
	}

	return ret;
}

void FreeLoadedStrings(void)
{
	if(LoadedStrings)
	{
		STRINGS* s;

		for(s = LoadedStrings; s; s = s->next)
			hfree(s->str);
	}

	return;
}
